
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>javascript检测数组 / 憋错料</title>

    <meta name="description" content="javascript检测数组 在ECMAScript5中的数组已经引入了isArray方法,该方法的目的就是检测变量是否为数组. 但是对于ie6.7等古老的浏览器是没有这样的方法的,在Zakas写的一本书上摘到一个函数,基本能优雅的满足大部分需求: 函数如下: 1 function isArray(arr) { 2 if (typeof Array.isArray === &quot;function&quot;) { 3 return Array.isArray(arr); 4 } else { 5 return Obje ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">javascript检测数组</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>在<strong>ECMAScript5</strong>中的数组已经引入了isArray方法，该方法的目的就是检测变量是否为数组。</p>
<p>但是对于ie6、7等古老的浏览器是没有这样的方法的，在<a href="http://www.nczonline.net/" rel="external nofollow noreferrer">Zakas</a>写的一本书上摘到一个函数，基本能优雅的满足大部分需求：</p>
<p>函数如下:</p>
<pre> 1 function isArray(arr) {
 2   if (typeof Array.isArray === "function") {
 3       return Array.isArray(arr);
 4   } else {
 5         return Object.prototype.toString.call(arr) === "[object Array]";
 6     }
 7 }
 8 /*
 9 *else里的代码解释
10 *call改变toString的this引用为待检测的对象，返回此对象的字符串表示，然
11 *后对比此字符串*是否是‘[object Array]‘，以判断其是否是Array的实例。这
12 *里不能直接调用Array的*toString的方法，因为它可能被修改，而Object
13 *是&ldquo;最原始&rdquo;对象，很少有人敢去碰它以及它**的属性，*所以能一定程度保证
14 *其&ldquo;纯洁性&rdquo;。
15 */</pre>
<p>当然还有一种比较不靠谱的方法，但是一般情况下还是能奏效的：</p>
<pre>1 function isArray(arr) {
2   return typeof arr.sort() === "function";
3 }
4 /*
5 *但是如果某个对象也含有sort方法，那么这个函数就寿终就寝了~~用这个
6 *方法是，你必须保证你代码里的所有js对象都不含有sort方法，这样才能
7 *保证这个方法正常执行。
8 */</pre>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-06 03:58:05 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/color/" title="color">color</a>, <a href="https://www.biecuoliao.com/tag/style/" title="style">style</a>, <a href="https://www.biecuoliao.com/tag/http/" title="http">http</a>, <a href="https://www.biecuoliao.com/tag/java/" title="java">java</a>, <a href="https://www.biecuoliao.com/tag/blog/" title="blog">blog</a>, <a href="https://www.biecuoliao.com/tag/strong/" title="strong">strong</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>javascript检测数组的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0KB5W9M.html" rel="bookmark">JavaScript学习笔记：检测数组方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				很多时候我们需要对JavaScript中数据类型( Function . String . Number . Undefined . Boolean 和 Object )做判断.在JavaScript中提供了typeof操作符可以对这些常用的数据类型做判断.但要使用typeof来判断数据是不是一个数组,就不起作用了.那在实际生产中要如何来检测数据是不是一个数组呢? 今天的学习任务就是如何来检测一个数据是不是数组? typeof操作符 typeof 可以解决大部分数据类型的检测,如: 1 cons			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MVYn2p4.html" rel="bookmark">私人定制javascript中数组小知识点&lpar;Only For Me&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				先上笑话,1.刚看到一个游泳的,想起公司组织去三亚旅游,老板跳海里,各种挣扎,捞上来老板第一句话:我记得我会游泳的啊. 2.媳妇说:老公对不起,我把你新买的自行车撞散架了! 老公:没事宝贝,你若安好,便是晴天! 媳妇说:老公你太有诗意了. 老公:滚犊子,安不好我整死你! 数组的概念 javascript数组是值得有序集合,不过它实属一个javascript对象的特殊形式,这是一个很重点的定性. 创建数组 1.var a=new Array();//等同于[] 2.var a=new Array(			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MmOWmQ3.html" rel="bookmark">JavaScript总结&mdash;数组</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Array类型 ECMAScript数组的每一项可以保存任何类型的数据. 创建数组的两种方式: (1)使用Array()构造函数 var colors = new Array(20); var colors = new Array(&quot;red&quot;,&quot;blue&quot;,&quot;green&quot;); (2)数组字面量表示法 var colors = [&quot;red&quot;,&quot;blue&quot;,&quot;green&quot;]; 修改.新增 v			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4N1yBJ3.html" rel="bookmark">PHP检测数组中的每个值是否含有特殊字符</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文出至:新太潮流网络博客 /** * [TestArray 检测数组是一维还是二维] * @E-mial [email protected] * @TIME 2017-04-07 * @WEB http://blog.iinu.com.cn * @param [type] $array [数组] */ function TestArray($array){ if(is_array($array)){ foreach($array as $v){ if(is_array($v)){ $Int_A			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MPb19B3.html" rel="bookmark">浅谈JavaScript中数组操作常用方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				JavaScript中数组操作常用方法 1.检测数组 1)检测对象是否为数组,使用instanceof 操作符 if(value instanceof Array) { //对数组执行某些操作 } 2)获取对象的类型,比较是否为object类型(此方法只能检测是否为Object,不推荐) if(typeof(value)==&quot;Object&quot;) { //对数组执行某些操作 } 3)检测对象是否为数组,使用Array.isArray()方法(只支持ie9+,firefox 4+,safar			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MV2xz2M.html" rel="bookmark">Javascript中数组的判断方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				摘要: 1.数组检测的方法: 1) typeof . 2) instanceof . 3) constructor . 4) Object.prototype.toString. 5) Array.isArray(). 以上为数组检测的方法,但是这些方法中: Array.isArray()方法是最为简单方便的方法,但是存在版本支持性问题,没有版本支持性问题且较好的检测方法是使用Object.prototype.toString结合call()方法来检查,通常数组检测中我们常用的做法是两种方法结合			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0nAO7NM.html" rel="bookmark">javascript： 数组详细操作方法及解析合集（9个改变8个不变12个遍历）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				改变原数组的方法(9个): 1 2 3 4 5 let a = [1,2,3]; ES5: a.pop()/ a.shift()/ a.push()/ a.unshift()/ a.reverse()/ a.splice()/ a.sort() ES6: a.copyWithin() / a.fill 对于这些能够改变原数组的方法,要注意避免在循环遍历中改变原数组的选项,比如: 改变数组的长度,导致遍历的长度出现问题. pop() 删除一个数组中的最后的一个元素 定义: pop() 方法删除一个			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0dlX7r0.html" rel="bookmark">javascript中数组的方法你真的都了解吗？</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本篇文章主要讲述ES5中的数组,包括数组两种创建方式,属性,以及 9 大类 ,总共23个操作方法,非常全面,看完之后ES5数组这一部分基本都了解了,下一篇文章,我会讲述ES6中对数组的加成,新增了哪些方法,以及定型数组,类数组和类数组的所有方法,记得关注哦! 数组作为javascript中最常用的数据类型之一,掌握好数组的方法在日常的开发中是非常有必要的,javascript中的数组相比其他语言来说更灵活,因为数组的每一项都可以是不同的数据类型,可以是对象,数组,字符串,数值等等,接下来一点一点			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0eZma53.html" rel="bookmark">建议9&colon;正确检测数组类型</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				由于数组和对象的数据同源性,导致在JavaScript编程中经常会出现:在必须数组时用了对象,在必须用对象时用了数组. typeof检测数组的类型时object,没有意义,所以这里可以通过自定义一个is_array函数来你部缺陷 var is_array = function(value){ return value &amp;&amp; typeof(value) === 'object' &amp;&amp; value.constructor === Array; } 但是,上面函数在识别从不同的窗			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0R8ld54.html" rel="bookmark" class="title">JAVA学习第五十九课 &mdash; 网络编程概述</a>
					<div>
						网络模型 OSI(Open System Interconnection)开放系统互连:參考模型 TCP/IP 网络通讯要素 IP地址 port号 传输协议 网络參考模型 七层OSI模型的基本概念要了 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mg5lwN3.html" rel="bookmark" class="title">基于Servlet、JSP、JDBC、MySQL的一个简单的用户注冊模块&lpar;附完整源代码&rpar;</a>
					<div>
						近期看老罗视频,做了一个简单的用户注冊系统.用户通过网页(JSP)输入用户名.真名和password,Servlet接收后通过JDBC将信息保存到MySQL中.尽管是个简单的不能再简单的东西,但麻雀虽 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MVY7Ey4.html" rel="bookmark" class="title">加入性能恢复工具：三星将在3月份推出新版SSD Magician软件 -行业新闻</a>
					<div>
						尽管三星在去年10月份就推出了修复方案,但在上个月的时候,仍有报道称一些三星840 EVO固态硬盘在刷入新固件后面临旧数据读取掉速的问题.有鉴于此,三星在周五下午发表了如下声明:“三星在10月份推出了 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rEVvw0.html" rel="bookmark" class="title">计算机网络 chapter 6 应用层</a>
					<div>
						第六章 应用层 每个应用层协议都是为了解决某一类应用问题,而问题的解决又往往是通过位于不同主机中的多个应用进程之间的通信和协同工作来完成的.应用层的具体内容就是规定应用进程在通信时所遵循的协议. 域名 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MX7VPX4.html" rel="bookmark" class="title">洛谷  P1608 路径统计</a>
					<div>
						题目描述 “RP餐厅”的员工素质就是不一般,在齐刷刷的算出同一个电话号码之后,就准备让HZH,TZY去送快餐了,他们将自己居住的城市画了一张地图,已知在他们的地图上,有N个地方,而且他们目前处在标注为 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/388nLy3.html" rel="bookmark" class="title">javascript动态添加表格以及获取数据</a>
					<div>
						&lt;script type=&quot;text/javascript&quot;&gt; var dict = { '百度': 'http://wwww.baidu.com', '新浪': 'h ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MV8g8k3.html" rel="bookmark" class="title">&lbrack;原创&rsqb;在Docker上部署mongodb分片副本集群。</a>
					<div>
						一.安装docker. 请参考:http://www.cnblogs.com/hehexiaoxia/p/6150584.html 二.编写dockerfile. #在根目录下创建dockerfile ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3vZE9X3.html" rel="bookmark" class="title">NFR</a>
					<div>
						你NFR了吗? NFR,即非功能性需求 (Non -Functional Requirements) ,即系统能够完成所期望的工作的性能与质量.具体包括如下内容: – 效率: 软件实现其功能所需要的计 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MVz2RzM.html" rel="bookmark" class="title">设计模式7原则小结</a>
					<div>
						面向对象设计原则和设计模式也是对系统进行合理重构的指导方针,增加我们的应用程序可维护性和可复用性常用的面向对象设计原则包括7个,这些原则并不是孤立存在的,它们相互依赖,相互补充.但是要牢记:[开闭原则 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0doe5zM.html" rel="bookmark" class="title">JMeter学习（四）参数化</a>
					<div>
						JMeter也有像LR中的参数化,本篇就来介绍下JMeter的参数化如何去实现. 参数化:录制脚本中有登录操作,需要输入用户名和密码,假如系统不允许相同的用户名和密码同时登录,或者想更好的模拟多个用户 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXvAOQ3.html" rel="bookmark" class="title">腾讯2017暑期实习生编程题（3题）</a>
					<div>
						第一题:给定一个字符串s,你可以从中删除一些字符,使得剩下的串是一个回文串.如何删除才能使得回文串最长呢?输出需要删除的字符个数. 思路:区间DP即可.我一开始想的是统计i~j内可以回文的字符个数,然 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0229gp0.html" rel="bookmark" class="title">【SpringMVC学习11】SpringMVC中的拦截器</a>
					<div>
						Springmvc的处理器拦截器类似于Servlet 开发中的过滤器Filter,用于对处理器进行预处理和后处理.本文主要总结一下springmvc中拦截器是如何定义的,以及测试拦截器的执行情况和使用 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0aRovn3.html" rel="bookmark" class="title">Socket&period;IO聊天室</a>
					<div>
						小编心语:大家过完圣诞准备迎元旦吧~小编在这里预祝大家元旦快乐!!这一次要分享的东西小编也不是很懂啊,总之小编把它拿出来是觉地比较稀奇,而且程序也没有那么难,是一个比较简单的程序,大家可以多多试试~  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0eEVvw0.html" rel="bookmark" class="title">PHPWAMP内置IIS管理器一键搭建PHP网站，支持无限个不同PHP版本同时运行</a>
					<div>
						PHPWAMP内置了功能强大的IIS站点管理,可同时运行多个PHP版本,站点管理可自定义添加PHP版本 使用方式:点击相关设置,直接打开IIS站点管理即可使用,如果你电脑没安装IIS,会自动快速安装  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rPpaqM.html" rel="bookmark" class="title">Cisco VPN学习第二天笔记</a>
					<div>
						1.IKEv1理论 IKE负责建立和维护IKE SAs 和 IPSec SAs 功能主要体现在如下几个方面: 对双方进行认证 交换公共密钥,产生密钥资源,管理密钥 协商协议参数(封装,加密,验证... ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4N1e683.html" rel="bookmark" class="title">做一个导航栏（bootstrap）</a>
					<div>
						&lt;div class=&quot;b&quot;&gt; &lt;div class=&quot;row&quot;&gt; &lt;div class=&quot;col-xs-2&quot; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLxjZyM.html" rel="bookmark" class="title">get&sol;post请求和 python 发起请求&lpar;4&rpar;</a>
					<div>
						get 请求: cgi-bin/hello_get.py #!C:/python27/python.exe # -*- coding: UTF-8 -*- import cgi, cgitb form ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/ME1bQgM.html" rel="bookmark" class="title">spring核心配置文件&lowbar;ActiveMQ消息队列配置</a>
					<div>
						&lt;?xml version=&quot;1.0&quot; encoding=&quot;UTF-8&quot;?&gt;&lt;beans xmlns=&quot;http://www.spr ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mm7vo13.html" rel="bookmark" class="title">Linux经常用到的命令</a>
					<div>
						1. Linux下用vim打开配置文件乱码,在终端输入:“LANG=”即可. 2. 查看端口是否被占用: 3. netstat -anp | grep port netstat -ltn 4. lso ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3raA6l0.html" rel="bookmark" class="title">心动恋人v1&period;0 pj（一）</a>
					<div>
						0x00  废话一堆 虽说要尊重开发者,但是这个东西,流氓软件.练手用 P.S. 我不是死宅 0x01 桃‘’色兑换码 看到这个,我还以为里面有什么儿童不宜的东西,兴奋了…… APKIDE搜索没有相关 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.032 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
